'************************************************************
'*Program obsugi serownika silnika krokowego z mikrokrokiem*
'*dla procesora ATTiny26 - wersja unipolatna                *
'*(c) ottop 2004-08                                         *
'************************************************************
$regfile = "at26def.dat"
Config Porta = &B11000000                                   'konfiguracja portw
Ddra = &B00111111
Config Portb = &B11111111
Config Portb = &B11111111
Ddrb = &B00001010

Enable Interrupts
Config Timer0 = Timer , Prescale = 1024
Start Timer0
'Enable Ovf0
On Ovf0 Int_tim1

Portb = Portb And &B00001010
Pllcsr.1 = 1                                                'w. PLL
Tccr1a = &B10101111                                         'Konfiguracja Timer1
Tccr1b = &B10000001                                         'do pracy w trybie PWM
Ocr1c = &HFF

Enable Int0                                                 'W. obsug External Interrup
On Int0 Int_step                                            'procedura obs. sygnau STEP
Ocr1a = 255
Ocr1b = 255




Dim Kroki(8) As Byte
Dim Krok As Byte
Dim Temp As Byte
Dim Flag1 As Bit

Kroki(1) = &B00000101
Kroki(2) = &B00000001
Kroki(3) = &B00001001
Kroki(4) = &B00001000
Kroki(5) = &B00001010
Kroki(6) = &B00000010
Kroki(7) = &B00000110
Kroki(8) = &B00000100

Do
' If Flag1 = 0 Then
'  If Pinb.6 = 1 Then
'   Flag1 = 1
'   If Pinb.5 = 0 Then
'     If Krok > 2 Then Decr Krok Else Krok = 8
'   Elseif Pinb.5 = 1 Then
'    If Krok < 8 Then Incr Krok Else Krok = 1
'   End If
'  Temp = Pina And &B11110000
'  Porta = Temp Or Kroki(krok)
'  End If
' Elseif Flag1 = 1 Then
'   If Pinb.6 = 0 Then Flag1 = 0
' End If

If Pina.6 = 0 Then
  Temp = Pina And &B11111100
  Porta = Temp
End If
If Pina.7 = 0 Then
  Temp = Pina And &B11110011
  Porta = Temp
End If
Loop

End                                                         'end program

Int_step:
  Disable Interrupts
  If Pinb.5 = 0 Then
    If Krok > 2 Then Decr Krok Else Krok = 8
  Elseif Pinb.5 = 1 Then
    If Krok < 8 Then Incr Krok Else Krok = 1
  End If
  Temp = Pina And &B11110000
  Porta = Temp Or Kroki(krok)
  Enable Interrupts
Return

Int_tim1:
  Temp = Pina And &B11110000
  Porta =temp or Kroki(krok)
Return